import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.StringTokenizer;
import java.util.Enumeration;
import java.util.Locale;
import java.util.ResourceBundle;
import java.util.TreeMap;

// @author loic

public class Traduc extends JFrame implements ActionListener {
	JLabel traduire_de=new JLabel(Logo.messages.getString("traduire_de")+" ");
	JLabel vers=new JLabel(" "+Logo.messages.getString("vers")+" ");
	Object[] choix={Logo.messages.getString("francais"),Logo.messages.getString("anglais"),Logo.messages.getString("gallois"),Logo.messages.getString("espagnol"),Logo.messages.getString("portugais"),Logo.messages.getString("esperanto")};
	JComboBox combo_origine=new JComboBox(choix);
	JComboBox combo_destination=new JComboBox(choix);
	JScrollPane js_source=new JScrollPane();
	JScrollPane js_destination=new JScrollPane();
	JTextArea origine=new JTextArea();
	JTextArea destination=new JTextArea();
	JPanel p_nord_origine =new JPanel();
	JPanel p_nord_destination =new JPanel();
	JPanel p_ouest =new JPanel();
	JPanel p_est=new JPanel();
	JPanel p_edition_origine=new JPanel();
	JPanel p_edition_destination=new JPanel();
	JButton traduire=new JButton(Logo.messages.getString("traduire"));
	ImageIcon icopier=new ImageIcon(Editeur.dimensionne_image("editcopy.png",this));
  ImageIcon icoller=new ImageIcon(Editeur.dimensionne_image("editpaste.png",this));
  ImageIcon icouper=new ImageIcon(Editeur.dimensionne_image("editcut.png",this));
  JButton copier_origine=new JButton(icopier);
  JButton coller_origine=new JButton(icoller);
  JButton couper_origine=new JButton(icouper);
  JButton copier_destination=new JButton(icopier);
  JButton coller_destination=new JButton(icoller);
  JButton couper_destination=new JButton(icouper);
  	
	ResourceBundle primitives_origine=null;
	ResourceBundle primitives_destination=null;
	TreeMap tre=new TreeMap();
		
	Traduc(){
		setTitle(Logo.messages.getString("traduire_procedure"));
		setIconImage(Toolkit.getDefaultToolkit().createImage(Traduc.class.getResource("icone.png")));
		setFont(Logo.police);
		traduire.setFont(Logo.police);
		vers.setFont(Logo.police);
		traduire_de.setFont(Logo.police);
		getContentPane().setLayout(new BorderLayout());

		p_nord_origine.add(traduire_de);
		p_nord_origine.add(combo_origine);
		p_nord_destination.add(vers);
		p_nord_destination.add(combo_destination);
		
		p_edition_origine.add(copier_origine);
		p_edition_origine.add(couper_origine);
		p_edition_origine.add(coller_origine);

		p_ouest.setLayout(new BorderLayout());
		p_ouest.add(js_source,BorderLayout.CENTER);
		p_ouest.add(p_edition_origine,BorderLayout.SOUTH);
		p_ouest.add(p_nord_origine,BorderLayout.NORTH);
		
		getContentPane().add(p_ouest,BorderLayout.WEST);

		p_edition_destination.add(copier_destination);
		p_edition_destination.add(couper_destination);
		p_edition_destination.add(coller_destination);

		p_est.setLayout(new BorderLayout());
		p_est.add(js_destination,BorderLayout.CENTER);
		p_est.add(p_edition_destination,BorderLayout.SOUTH);
		p_est.add(p_nord_destination,BorderLayout.NORTH);
		
		getContentPane().add(p_est,BorderLayout.EAST);
		getContentPane().add(traduire,BorderLayout.CENTER);
		
		js_source.getViewport().add(origine);
		js_destination.getViewport().add(destination);
		js_source.setPreferredSize(new Dimension(300,300));
		js_destination.setPreferredSize(new Dimension(300,300));

		traduire.addActionListener(this);
		copier_destination.addActionListener(this);
		couper_destination.addActionListener(this);
		coller_destination.addActionListener(this);
		copier_origine.addActionListener(this);
		couper_origine.addActionListener(this);
		coller_origine.addActionListener(this);
		copier_origine.setActionCommand("copier_origine");
		couper_origine.setActionCommand("couper_origine");
		coller_origine.setActionCommand("coller_origine");
		coller_destination.setActionCommand("coller_destination");
		copier_destination.setActionCommand("copier_destination");
		couper_destination.setActionCommand("couper_destination");

		pack();
		setVisible(true);
	}
	
	public void actionPerformed(ActionEvent e){
		 String cmd=e.getActionCommand();
		if (Logo.messages.getString("traduire").equals(cmd)){
			String texte=origine.getText();
			primitives_origine=genere_langue(combo_origine);
			primitives_destination=genere_langue(combo_destination);
			Enumeration en=primitives_origine.getKeys();
			while (en.hasMoreElements()){
				String element=en.nextElement().toString();
				String primitives=primitives_origine.getString(element);
				String primitives2=primitives_destination.getString(element);
				StringTokenizer st=new StringTokenizer(primitives);
				StringTokenizer st2=new StringTokenizer(primitives2);
				int compteur=st.countTokens();
				for (int i=0;i<compteur;i++){
					if (st2.hasMoreTokens()) element=st2.nextToken();
					tre.put(st.nextToken(),element);				
				}
			}
			// ajout des mots cls pour et fin
			int id=combo_origine.getSelectedIndex();
			Locale locale=Logo.genere_locale(id);
			ResourceBundle res1=ResourceBundle.getBundle("langage",locale);
			id=combo_destination.getSelectedIndex();
			locale=Logo.genere_locale(id);
			ResourceBundle res2=ResourceBundle.getBundle("langage",locale);
			tre.put(res1.getString("pour"),res2.getString("pour"));
			tre.put(res1.getString("fin"),res2.getString("fin"));
			StringTokenizer st=new StringTokenizer(texte," */+-\n|&()[]",true);
			String traduc="";
			while (st.hasMoreTokens()){
				String element=st.nextToken().toLowerCase();
				if (tre.containsKey(element)) traduc+=tre.get(element).toString();	
				else traduc+=element;
			}
			destination.setText(traduc);
		}
		else if ("copier_origine".equals(cmd)) {
			origine.copy();
		}
		else if ("couper_origine".equals(cmd)) {
			origine.cut();
		}
		else if ("coller_origine".equals(cmd)) {
			origine.paste();
		}
		else if ("copier_destination".equals(cmd)) {
			destination.copy();
		}
		else if ("couper_destination".equals(cmd)) {
			destination.cut();
		}
		else if ("coller_destination".equals(cmd)) {
			destination.paste();
		}
	}
 ResourceBundle genere_langue(JComboBox jc){ // fixe la langue utilise pour les messages
	  Locale locale=null;
	  int id=jc.getSelectedIndex();
		locale=Logo.genere_locale(id);
		return ResourceBundle.getBundle("primitives",locale);
	}
}
