import java.awt.*;
import java.io.*;

import javax.swing.JColorChooser;
import javax.swing.JFileChooser;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.BadLocationException;
import javax.swing.text.StyledDocument;
import javax.swing.text.rtf.RTFEditorKit;

import java.util.ResourceBundle;
import java.util.Locale;
import java.util.Stack;
public class MenuListener implements ActionListener{
  Cadre cadre;
  Preference pf=null;
  Dialogueimage diag=null;
  Demarrage dem=null;
	Traduc traduc=null;
  public MenuListener() {
  }
  public MenuListener(Cadre cadre){
    this.cadre=cadre;
  }
	public static void recursivelySetFonts(Component comp, Font font) {
    comp.setFont(font);
    if (comp instanceof Container) {
      Container cont = (Container) comp;
			for(int j=0, ub=cont.getComponentCount(); j<ub; ++j)
				recursivelySetFonts(cont.getComponent(j), font);
      }
   }
  public void actionPerformed(ActionEvent e){
    String cmd=e.getActionCommand();
    if (Logo.messages.getString("quitter").equals(cmd)){     //Quitter
			cadre.setVisible(true);
			String[] choix={Logo.messages.getString("ok"),Logo.messages.getString("annuler")};
			JLabel jlab=new JLabel(Logo.messages.getString("quitter?"));
			jlab.setFont(Logo.police);
			ImageIcon icone=new ImageIcon(Cadre.class.getResource("icone.png"));
	  int retval=JOptionPane.showOptionDialog(cadre,jlab,Logo.messages.getString("quitter"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE,icone,choix,choix[0]);	
      if (retval==JOptionPane.OK_OPTION){
// On crit le fichier de configuration
        cadre.ecris_config();
        System.exit(0);
      }
    }
    else if (Logo.messages.getString("copier").equals(cmd)){   //Copier
      cadre.commande.copy();
    }
    else if (Logo.messages.getString("couper").equals(cmd)){   //Couper
      cadre.commande.cut();
    }
    else if (Logo.messages.getString("coller").equals(cmd)){   //Coller
      cadre.commande.paste();
    }
    else if(Logo.messages.getString("nouveau").equals(cmd)){ //nouveau
		cadre.jMenuFileNouveau.setEnabled(false);
		String[] choix={Logo.messages.getString("ok"),Logo.messages.getString("annuler")};
		Object message=Logo.messages.getString("enregistrer_espace");
		ImageIcon icone=new ImageIcon(Cadre.class.getResource("icone.png"));
		int retval=JOptionPane.showOptionDialog(cadre,message,Logo.messages.getString("enregistrer_espace"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE,icone,choix,choix[0]);	
		if (retval==JOptionPane.OK_OPTION){
			for (int i = cadre.primitive.nbproc - 1; i > -1; i--) {
			  Procedure procedure = (Procedure) cadre.primitive.procedure.get(i);
			  if (procedure.affichable == true)
				cadre.primitive.procedure.remove(i);
			}
			if (null!=Cadre.path) {
				Cadre.path=null;
				cadre.setTitle("XLOGO");
			}
			cadre.primitive.nbproc = cadre.primitive.procedure.size();
			Cadre.globale = new Stack();
			Cadre.valeur = new Stack();
		  }
		  else cadre.jMenuFileNouveau.setEnabled(true);
    }
    else if(Logo.messages.getString("enregistrer").equals(cmd)|Logo.messages.getString("enregistrer_sous").equals(cmd)){   //Enregistrer
      String path=Cadre.path;
      if (Logo.messages.getString("enregistrer_sous").equals(cmd)||null==path) {
        JFileChooser jf=new JFileChooser(LancePrimitive.SortieTexte(Logo.repertoire_defaut));
        jf.addChoosableFileFilter(new ExtensionFichier(Logo.messages.getString("fichiers_logo"),".lgo"));
				recursivelySetFonts(jf,Logo.police);
        int retval=jf.showDialog(cadre,Logo.messages.getString("enregistrer"));
        if (retval==JFileChooser.APPROVE_OPTION){
          path=jf.getSelectedFile().getPath();
          String path2=path.toLowerCase();  // on garde la casse du path pour les systmes d'exploitation faisant la diffrence
          if (!path2.endsWith(".lgo")) path+=".lgo";
          Cadre.path=path;
					cadre.jMenuFileEnregistrer.setEnabled(true);
					cadre.setTitle("XLOGO"+"          "+path);
					try {
						File f=new File(path);
						Logo.repertoire_defaut=Logo.rajoute_backslash(f.getParent());
					}
					catch(NullPointerException e2){}
        }
      }
      try{
        String aecrire="";
        RandomAccessFile f=new RandomAccessFile(path,"rw");
        try {
          for (int i = 0; i < cadre.primitive.procedure.size(); i++) {
            Procedure procedure = ( (Procedure) cadre.primitive.procedure.get(
                i));
            if (procedure.affichable){
              aecrire += Logo.messages.getString("pour") + " " + procedure.name;
              for (int j = 0; j < procedure.nbparametre; j++) {
                aecrire += " :" + procedure.variable.get(j).toString();
              }
              aecrire += "\n" + procedure.instruction + Logo.messages.getString("fin") + "\n\n";
            }
          }
        }catch(NullPointerException ex){} //Si aucune procdure n'a t dfinie.
        f.writeUTF(aecrire);
        f.close();
      }
      catch(NullPointerException e3){System.out.println("annulation");} //Si l'utilisateur annule
      catch(FileNotFoundException e1){}
      catch(IOException e2){cadre.panneauHistorique1.ecris("erreur",Logo.messages.getString("ioecriture"));}
		}
    else if(Logo.messages.getString("ouvrir").equals(cmd)){              //Ouvrir
      JFileChooser jf=new JFileChooser(LancePrimitive.SortieTexte(Logo.repertoire_defaut));
      jf.addChoosableFileFilter(new ExtensionFichier(Logo.messages.getString("fichiers_logo"),".lgo"));
			recursivelySetFonts(jf,Logo.police);
      int retval=jf.showDialog(cadre,Logo.messages.getString("ouvrir"));
      if (retval==JFileChooser.APPROVE_OPTION){
        String txt="";
        String path=jf.getSelectedFile().getPath();
        try{
          RandomAccessFile f=new RandomAccessFile(path,"r");
          f.seek(0);
          txt=f.readUTF();
          f.close();
        }
        catch(FileNotFoundException e1){System.out.println("Fichier non trouv");}
        catch(IOException e2){//Si ce n'est pas de L'utf-8
          System.out.println("Fichier non cr par xlogo");
          try{
            RandomAccessFile f=new RandomAccessFile(path,"r");
            f.seek(0);
            long position=0;
            while (position<f.length()){
              txt+=f.readLine()+"\n";
              position=f.getFilePointer();
            }
          }
          catch(IOException e3){cadre.panneauHistorique1.ecris("erreur",Logo.messages.getString("iolecture"));}
        }
        if (!txt.equals("")){
          if (!cadre.editeur.isVisible()) cadre.editeur.setVisible(true);
         	 cadre.editeur.zonedition.ecris(txt);
        }
       cadre.tmp_path=path;
			}
    }
    else if(Logo.messages.getString("couleurfond").equals(cmd)){      //couleur du fond
			Color color=JColorChooser.showDialog(cadre,Logo.messages.getString("couleur_du_fond"),cadre.couleurfond);
    if (null!=color){
      Locale locale=Logo.genere_locale(Logo.langage);
      java.util.ResourceBundle rs=java.util.ResourceBundle.getBundle("primitives",locale);
      String fcfg=rs.getString("fcfg");
      fcfg=fcfg.substring(0,fcfg.indexOf(" "));
      cadre.panneauHistorique1.ecris("commentaire",fcfg+" ["+color.getRed()+" "+color.getGreen()+" "+color.getBlue()+"]\n");
      Graphics g=cadre.ardoise1.dessin.getGraphics();
      g.setColor(color);
      g.fillRect(0,0,Logo.largeur_dessin,Logo.hauteur_dessin);
      cadre.couleurfond=color;
      cadre.primitive.videecran();
      Graphics graph=cadre.ardoise1.getGraphics();
      graph.setClip((int)cadre.tortue.corX-26,(int)cadre.tortue.corY-26,52,52);
      graph.drawImage(cadre.ardoise1.dessin,0,0,cadre.ardoise1);
      cadre.ardoise1.repaint();
    }
   }
   else if(Logo.messages.getString("couleurcrayon").equals(cmd)){      //Couleur du crayon
    Color color=JColorChooser.showDialog(cadre,Logo.messages.getString("couleur_du_crayon"),cadre.tortue.couleurcrayon);
    if (null!=color){
      Locale locale=Logo.genere_locale(Logo.langage);
      java.util.ResourceBundle rs=java.util.ResourceBundle.getBundle("primitives",locale);
      String fcc=rs.getString("fcc");
      fcc=fcc.substring(0,fcc.indexOf(" "));
      cadre.panneauHistorique1.ecris("commentaire",fcc+" ["+color.getRed()+" "+color.getGreen()+" "+color.getBlue()+"]\n");
      cadre.tortue.couleurcrayon=color;
    }
  }
  else if(Logo.messages.getString("preferences").equals(cmd)){  //preferences
			if (cadre.editeur.isVisible()) JOptionPane.showMessageDialog(cadre,Logo.messages.getString("ferme_editeur"),Logo.messages.getString("erreur"),JOptionPane.ERROR_MESSAGE);
			else if (null==pf) {
				pf=new Preference(cadre);
				pf.setBounds(100,100,600,580);
				pf.setVisible(true);
			}
			else {pf.toFront();}
  }
	else if(Logo.messages.getString("traduire_procedure").equals(cmd)){
		if (null==traduc||!traduc.isVisible()){
      traduc=new Traduc();
			traduc.setVisible(true);
    }
    else traduc.toFront();
	}
	else if (Logo.messages.getString("copier_image").equals(cmd)){  // Copier l'image au presse-papier
    if (null==diag){
      diag = new Dialogueimage(cadre, Logo.messages.getString("copier_image"));
      diag.setBounds(cadre.getX(), cadre.getY(), cadre.getWidth() / 2,
                     cadre.getHeight() / 4);
      diag.setVisible(true);
    }
    else diag.toFront();
  }
  else if (Logo.messages.getString("enregistreimage").equals(cmd)){  //Enregistrer l'image au format png ou jpg
    if (null==diag){
      diag = new Dialogueimage(cadre, Logo.messages.getString("enregistrer"));
      diag.setBounds(cadre.getX(), cadre.getY(), cadre.getWidth() / 2,
                     cadre.getHeight() / 4);
      diag.setVisible(true);
    }
    else diag.toFront();
  }
  else if (Logo.messages.getString("imprimer").equals(cmd)){    //imprimer l'image
    if (null==diag){
      diag=new Dialogueimage(cadre,Logo.messages.getString("imprimer"));
      diag.setBounds(cadre.getX(),cadre.getY(),cadre.getWidth()/2,cadre.getHeight()/4);
      diag.setVisible(true);
    }
    else diag.toFront();
  }
  else if (Logo.messages.getString("enregistrer_rtf").equals(cmd)){
  	RTFEditorKit myRTFEditorKit = new RTFEditorKit();
   	StyledDocument myStyledDocument =cadre.panneauHistorique1.historique.getStyledDocument();
   	try{
   		JFileChooser jf=new JFileChooser(LancePrimitive.SortieTexte(Logo.repertoire_defaut));
  	    jf.addChoosableFileFilter(new ExtensionFichier(Logo.messages.getString("fichiers_rtf"),".rtf"));
  	    MenuListener.recursivelySetFonts(jf,Logo.police);
  	    int retval=jf.showDialog(cadre,Logo.messages.getString("enregistrer"));
  	    if (retval==JFileChooser.APPROVE_OPTION){
  	    	String path=jf.getSelectedFile().getPath();
  	        String path2=path.toLowerCase();  // on garde la casse du path pour les systmes d'exploitation faisant la diffrence
  	        if (!path2.endsWith(".rtf")) path+=".rtf";
  	        	FileOutputStream myFileOutputStream = new FileOutputStream(path);
	  	    	myRTFEditorKit.write(myFileOutputStream, myStyledDocument, 0,myStyledDocument.getLength()-1);
	  	    	myFileOutputStream.close();
  	         }
  	    }
  	    catch(FileNotFoundException e1){}
  	    catch(IOException e2){}
  	    catch(BadLocationException e3){}
  	    catch(NullPointerException e4){}
  }
  else if (Logo.messages.getString("a_propos").equals(cmd)){   //Bote de dialogue  props
		String message=Logo.messages.getString("message_a_propos1")+Logo.version+"\n"+Logo.messages.getString("message_a_propos2")+"\n"+Logo.messages.getString("message_a_propos3")+"\n     "+Logo.messages.getString("message_a_propos4");
		JTextArea jt=new JTextArea(message);
		jt.setEditable(false);
		jt.setBackground(new Color(255,255,177));
		jt.setFont(Logo.police);
    ImageIcon icone=new ImageIcon(Cadre.class.getResource("icone.png"));
		JOptionPane.showMessageDialog(cadre,jt,Logo.messages.getString("a_propos"),JOptionPane.INFORMATION_MESSAGE,(Icon)icone);
  }
  else if (Logo.messages.getString("licence").equals(cmd)|Logo.messages.getString("licence_francais").equals(cmd)){     // Affichage de la licence
   JFrame frame=new JFrame("Licence");
    frame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    frame.setSize(500,500);
    JScrollPane scroll=new JScrollPane();
    JTextPane texte=new JTextPane();
    texte.setEditable(false);
    scroll.getViewport().add(texte);
    frame.getContentPane().add(scroll);
    ResourceBundle gpl=null;
    if (Logo.messages.getString("licence").equals(cmd))  gpl=ResourceBundle.getBundle("gpl",Logo.genere_locale(1));
    else gpl=ResourceBundle.getBundle("gpl",Logo.genere_locale(Logo.langage));
    texte.setFont(Logo.police);
    texte.setText(gpl.getString("gpl"));
    texte.setCaretPosition(0);
    scroll.getVerticalScrollBar().setValue(0);
    frame.setVisible(true);

/*  String file="gpl_bresil";
  if (cmd.equals(Logo.messages.getString("licence_francais"))) { //Si c'est la traduction de la licence qui est demande
    switch(Logo.langage){
      case 0:
        file="gpl_francais";
        break;
      case 1:
        file="gpl_anglais";
        break;
      case 2:
        file="gpl_gallois";
       break;
       case 3:
       file="gpl_espagnol";
			 break;
			 case 4:
			file="gpl_bresil";
			break;
    }
  System.out.println(file);
  JFrame frame2=new JFrame("Licence");
  frame2.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
  frame2.setSize(500,500);
  JScrollPane scroll2=new JScrollPane();
  JTextPane texte2=new JTextPane();
  texte2.setEditable(false);
  scroll2.getViewport().add(texte2);
  frame2.getContentPane().add(scroll2);
  try{  texte2.setPage(this.getClass().getResource(file));
 java.util. StringTokenizer st= new java.util.StringTokenizer(texte2.getText(),"\n");
  String liste="";

  while(st.hasMoreTokens()){
  liste+=st.nextToken()+"\\n";
  }
  java.io.RandomAccessFile fi=new java.io.RandomAccessFile("/home/loic/test","rw");
  try{
  	fi.writeUTF(liste);
  	fi.close();
  }
  catch(IOException e1){System.out.println("ca marche pas");}
  //System.out.println(liste);

  }

  catch(IOException ex){System.out.println(ex.toString());}
  frame2.setVisible(true);}*/
 
  }  
  else if (Logo.messages.getString("definir_demarrage").equals(cmd)){   // dfinir les fichiers de dmarrage
    if (null==dem||!dem.isVisible()){
      dem=new Demarrage(cadre);
      dem.setBounds(100,100,400,250);
      dem.setVisible(true);
    }
    else dem.toFront();
  }
  }
}
